#include <stdio.h>
#include <ctype.h>
#include "SocketCommand.h"
#include "log.h"


void bzero( void* ptr, int size ) {
	memset( ptr, 0, size );
}

static int wsaInitialized = 0;


SocketCommand::SocketCommand(int port) {
	WORD wVersionRequested;
	WSADATA wsaData;
	int err;
	connfd = -1;
 
	if ( !wsaInitialized ) {
		wsaInitialized = 1;
		wVersionRequested = MAKEWORD( 2, 2 );
 
		err = WSAStartup( wVersionRequested, &wsaData );

		if ( err != 0 ) {
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			log_error("WSAStartup didn't fucking work!\n");
		}
 
		/* Confirm that the WinSock DLL supports 2.2.*/
		/* Note that if the DLL supports versions greater    */
		/* than 2.2 in addition to 2.2, it will still return */
		/* 2.2 in wVersion since that is the version we      */
		/* requested.                                        */
 
		if ( LOBYTE( wsaData.wVersion ) != 2 ||
				HIBYTE( wsaData.wVersion ) != 2 ) {
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			WSACleanup( );
			log_error( "Unexpeced error");
		}
	}
 
	/* The WinSock DLL is acceptable. Proceed. */

    listenfd = socket(AF_INET, SOCK_STREAM, 0);

    bzero(&servaddr, sizeof(servaddr));
    servaddr.sin_family      = AF_INET;
    servaddr.sin_addr.s_addr = htonl( INADDR_ANY );
    servaddr.sin_port        = htons( port );

	log_message( "calling bind");

    bind(listenfd, (const struct sockaddr*)&servaddr, sizeof(servaddr));

	log_message( "calling listen" );
	listen( listenfd, 5 );
}


extern "C" int
Readline(int fd, void *ptr, int maxlen);

char* SocketCommand::GetCommand() {
	int clilen = 0;
    clilen = sizeof(cliaddr);

	if ( connfd == -1 ) {
		if ( (connfd = accept(listenfd, (struct sockaddr*)&cliaddr, &clilen)) < 0) {
			log_error( "accept error" );
			exit( 0 );
		}
	}
        
	/* connection closed by other end */
	command[0] = 0;
	int n;
	if ( (n = Readline(connfd, command, MAXLINE)) == 0) {
		log_error( "readline failed");
		connfd = -1;
	}
	//log_command( command );
	return &command[0];
}


