#include "cortona.h"

class VisualObject {
public:
	VisualObject( INodeObject* transformNode );
	void SetScriptInputs( ISFInt32Object* in1, ISFInt32Object* in2, ISFInt32Object* in3, ISFInt32Object* in4, ISFInt32Object* in5 );
	ISFInt32Object* getIn1() { return( script_in1 ); }
	ISFInt32Object* getIn2() { return( script_in2 ); }
	ISFInt32Object* getIn3() { return( script_in3 ); }
	ISFInt32Object* getIn4() { return( script_in4 ); }
	void SetEmbeddedTransform( INodeObject* xform );
	void SetScale( ISFVec3fObject* s ) { pScale = s; }
	ISFVec3fObject* getScale() { return( pScale ); }
	void SetRotation( ISFRotationObject* r ) { pRotation = r; }
	ISFRotationObject* getRotation() { return( pRotation ); }
	INodeObject* getTransform() { return( pTransformNode ); }
	IMFNodeObject* getGroup() { return( pGroup ); }
	void SetGroup( IMFNodeObject* g ) { pGroup = g; }

private:
	INodeObject* pTransformNode;  // root of this hierarchy
	IMFNodeObject* pGroup;        // "children" element of the above Transform node

	ISFInt32Object* script_in1;   // integer inputs for script node
	ISFInt32Object* script_in2;
	ISFInt32Object* script_in3;
	ISFInt32Object* script_in4;
	ISFInt32Object* script_in5;

	INodeObject* embeddedTransform;

	ISFVec3fObject* pScale;
	ISFRotationObject* pRotation;

	VisualObject* children; // first child
	VisualObject* next;     // next in linked list
};
